section\<open>TLS\<close>
theory NSLclassic
  imports "Automated_Stateful_Protocol_Verification.PSPSP"
begin

declare [[pspsp_timing]]

trac\<open>
Protocol: nslclassic

Types:
honest = {a,b}
dishon = {i}
agent = honest ++ dishon

Sets:
challenged/2
responded/2

Functions:

Public crypt/2 pair/2 pk/1 triple/3 nonce/1
Private inv/1

Analysis:

pair(X,Y) -> X,Y
triple(X,Y,Z) -> X,Y,Z
crypt(X,Y) ? inv(X) -> Y
nonce(X) -> X

Transactions:

a1b(A: dishon)
send inv(pk(A)).

a6()
new NA
send NA.

step1(A: honest, B: agent)
new NA
insert NA challenged(A,B)
send crypt(pk(B),pair(NA,A)).

step2(B: honest, A: agent, NA: value)
receive crypt(pk(B),pair(NA,A))
new NB
insert NB challenged(B,A)
send crypt(pk(A),triple(NA,NB,B)).

step3(A: honest, B: agent, NA: value, NB: value)
receive crypt(pk(A),triple(NA,NB,B))
NA in challenged(A,B)
insert NA responded(A,B)
delete NA challenged(A,B)
send crypt(pk(B),nonce(NB)).

step3receive(B: honest, A: agent, NB: value)
receive crypt(pk(B),nonce(NB))
NB in challenged(B,A)
delete NB challenged(B,A)
insert NB responded(B,A).

att1(A: honest, B: honest, NA: value)
receive NA
NA in challenged(A,B)
attack.

att2(A: honest, B: honest, NA: value)
receive NA
NA in responded(A,B)
attack.

\<close>

subsection \<open>Protocol model setup\<close>
protocol_model_setup spm: nslclassic


subsection \<open>Fixpoint computation\<close>
compute_fixpoint nslclassic_protocol nslclassic_fixpoint
value "let (FP,_,TI) = nslclassic_fixpoint in (size FP, size TI)"


subsection \<open>Proof of security\<close>
protocol_security_proof ssp: nslclassic


subsection \<open>The generated theorems and definitions\<close>
thm ssp.protocol_secure

thm nslclassic_enum_consts.nchotomy
thm nslclassic_sets.nchotomy
thm nslclassic_fun.nchotomy
thm nslclassic_atom.nchotomy
thm nslclassic_arity.simps
thm nslclassic_public.simps
thm nslclassic_\<Gamma>.simps
thm nslclassic_Ana.simps

thm nslclassic_protocol_def

end
